package com.wyattjmiller.dicerollerapp

import androidx.appcompat.app.AppCompatActivity
import android.os.Bundle
import android.util.Log
import android.view.View
import android.widget.Button
import android.widget.TextView

class CoinActivity : AppCompatActivity() {

    // Private member variables per the layout
    private lateinit var mCoinTextView: TextView
    private lateinit var mFlipButton: Button

    // Private member variable - other
    private lateinit var mCoinStatus: Coin

    // The following methods are for keeping track of the Android lifecycle using Logcat
    override fun onCreate(savedInstanceState: Bundle?) {
        super.onCreate(savedInstanceState)
        setContentView(R.layout.activity_coin)

        mCoinTextView = findViewById(R.id.coinTextView)
        mFlipButton = findViewById(R.id.flipButton)

        mCoinTextView.visibility = View.INVISIBLE
    }

    override fun onStart() {
        Log.d("LIFECYCLE", "onStart invoked!")
        super.onStart()
    }

    override fun onResume() {
        Log.d("LIFECYCLE", "onResume invoked!")
        super.onResume()
    }

    override fun onPause() {
        Log.d("LIFECYCLE", "onPause invoked!")
        super.onPause()
    }

    override fun onStop() {
        Log.d("LIFECYCLE", "onStop invoked!")
        super.onStop()
    }

    override fun onDestroy() {
        Log.d("LIFECYCLE", "onDestroy invoked!")
        super.onDestroy()
    }

    // code behind for the 'flip' button
    fun onClickCoinFlip(view: View?) {
        when (Randomizer().randomCoinFlip()) {
            0 -> {
                mCoinStatus = Coin.Heads
                mCoinTextView.text = mCoinStatus.toString()
            }
            1 -> {
                mCoinStatus = Coin.Tails
                mCoinTextView.text = mCoinStatus.toString()
            }
        }

        if (mCoinTextView.visibility == View.INVISIBLE) {
            mCoinTextView.visibility = View.VISIBLE
        }
    }
}