package com.wyattjmiller.dicerollerapp

import android.content.Intent
import androidx.appcompat.app.AppCompatActivity
import android.os.Bundle
import android.util.Log
import android.view.View
import android.widget.Button
import androidx.appcompat.app.AppCompatDelegate

class MainActivity : AppCompatActivity() {

    // Private member variables per the layout
    private lateinit var mCoinButton: Button
    private lateinit var mDieButton: Button

    // Private member variable - other
    private lateinit var mIntent: Intent

    // The following methods are for keeping track of the Android lifecycle using Logcat
    // Very useful, much wow
    // Android's lifecycle is so much fun lol :P
    override fun onCreate(savedInstanceState: Bundle?) {
        super.onCreate(savedInstanceState)
        setContentView(R.layout.activity_main)

        // dark mode, for those who need it, like me :P
        AppCompatDelegate.setDefaultNightMode(AppCompatDelegate.MODE_NIGHT_FOLLOW_SYSTEM)

        mCoinButton = findViewById(R.id.coinButton)
        mDieButton = findViewById(R.id.diceButton)
    }

    override fun onStart() {
        Log.d("LIFECYCLE", "onStart invoked!")
        super.onStart()
    }

    override fun onResume() {
        Log.d("LIFECYCLE", "onResume invoked!")
        super.onResume()
    }

    override fun onPause() {
        Log.d("LIFECYCLE", "onPause invoked!")
        super.onPause()
    }

    override fun onStop() {
        Log.d("LIFECYCLE", "onStop invoked!")
        super.onStop()
    }

    override fun onDestroy() {
        Log.d("LIFECYCLE", "onDestroy invoked!")
        super.onDestroy()
    }

    // code behind the 'flip the coin' button
    fun onClickCoin(view: View?) {
        mIntent = Intent(this, CoinActivity::class.java)
        startActivity(mIntent)
    }

    // code behind the 'roll dice' button
    fun onClickDie(view: View?) {
        mIntent = Intent(this, DiceActivity::class.java)
        startActivity(mIntent)
    }
}